package com.madeu.controller.web.webpopbillpoint;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webpopbillpoint.WebPopbillPointService;
import com.madeu.util.HttpUtil;
import com.madeu.util.RequestLogUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.HashMap;

@Slf4j
@Controller
public class WebPopbillPointController extends ManagerDraftAction{

	@Autowired
	private WebPopbillPointService webPopbillPointService;

	@Autowired
	private WebLogHistoryService webLogHistoryService;

	/**
	 * 잔여 포인트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webpopbillpoint/selectPopbillPoint.do")
	@ResponseBody
	public HashMap<String, Object> selectPopbillPoint(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
			
		log.debug("WebPopbillPointController selectPopbillPoint START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		StringBuffer errorMsg = new StringBuffer();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webPopbillPointService.selectPopbillPoint(paramMap);
			}
		}catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();
	
				insertMap.put("url", "/webpopbillpoint/selectPopbillPoint.do");
				insertMap.put("func", "selectPopbillPoint");
				insertMap.put("funcName", "잔여 포인트 조회");
				insertMap.put("service", "webPopbillPointService");
				insertMap.put("serviceName", "잔여 포인트 조회");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
	
				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		
		log.debug("WebPopbillPointController selectPopbillPoint END");
		
		return map;
	}
	
	/**
	 * 포인트 충전 이동
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webpopbillpoint/chargePopbillPointIntro.do")
	@ResponseBody
	public HashMap<String, Object> chargePopbillPointIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
			
		log.debug("WebPopbillPointController chargePopbillPoint START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		StringBuffer errorMsg = new StringBuffer();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("regId", String.valueOf(session.getAttribute("loginMemberId")));
				paramMap.put("modId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webPopbillPointService.chargePopbillPointIntro(paramMap);
			}
		}catch (Exception e) {
			e.printStackTrace();
			errorMsg.append(e);
		}finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}

			try {
				HashMap<String, Object> visitLogParamMap = RequestLogUtil.getVisitLogParameterMap(request);
				HashMap<String, Object> insertMap = new HashMap<String, Object>();
	
				insertMap.put("url", "/webpopbillpoint/chargePopbillPointIntro.do");
				insertMap.put("func", "chargePopbillPointIntro");
				insertMap.put("funcName", "포인트 충전 이동");
				insertMap.put("service", "webPopbillPointService");
				insertMap.put("serviceName", "포인트 충전 이동");
				insertMap.put("requestValue", String.valueOf(paramMap));
				insertMap.put("responseValue", String.valueOf(map));
				insertMap.put("tId", map.get("tId"));
				if((String.valueOf(errorMsg)).equals("") || (String.valueOf(errorMsg) == null) || String.valueOf(errorMsg).length() == 0){
					insertMap.put("resultCode", "SUCCESS");
				}
				else{
					insertMap.put("resultCode", "ERROR");
				}
				insertMap.put("resultMsg", String.valueOf(errorMsg));
				insertMap.put("muMemberId", paramMap.get("loginMemberId"));
	
				webLogHistoryService.insertLogHistory(insertMap, visitLogParamMap);
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		
		log.debug("WebPopbillPointController chargePopbillPointIntro END");
		
		return map;
	}
}
